// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Header Files
// -------------------------------------------------------------------------------------------------

#include <stdio.h>
#include <windows.h>

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Subroutine to dump buffer contents to a file
// -------------------------------------------------------------------------------------------------

void DumpBuffer (char *Buffer, int Size, const char *Filename)

{
	FILE *File;
	if ((File = fopen (Filename, "wb")) != NULL)
	{
		int Counter = 0x00;
		while (Counter != Size)
		{
			fputc (Buffer [Counter++], File);
		}
		fclose (File);
	}
}

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Subroutine to reallocate a Memory space (For char)
// -------------------------------------------------------------------------------------------------

int AllocChar (char *&MemoryOld, int &MemorySize, int NewSize)

{
	char *Memory = (char*) malloc (NewSize + 0x01);
	if (Memory == NULL)
	{
		return (0x01);
	}
	else
	{
		if (NewSize > MemorySize)
		{
			memcpy (Memory, MemoryOld, MemorySize);
		}
		else
		{
			memcpy (Memory, MemoryOld, NewSize);
		}
	}
	free (MemoryOld);
	MemorySize = NewSize;
	MemoryOld = Memory;
	return (0x00);
}

// =================================================================================================
